diff --git a/data/particles.json b/data/particles.json
index f5d73172d..f73bd3822 100644
--- a/data/particles.json
+++ b/data/particles.json
@@ -255,6 +255,16 @@
       "WallBounces": false,
       "ZDarken": true
     },
+    {
+      "Name": "health_plus",
+      "Pic": {
+        "Type": "Animated",
+        "Sprites": "health_plus",
+        "TicksPerFrame": 10
+      },
+      "Range": 70,
+      "GravityFactor": -0.2
+    },
     {
       "Name": "ammo_text",
       "Type": "Text",
diff --git a/graphics/health_plus.txt b/graphics/health_plus.txt
new file mode 100644
index 000000000..3e02b809b
--- /dev/null
+++ b/graphics/health_plus.txt
@@ -0,0 +1,5 @@
+Adapted from RetroPixel Icons V1 (9x9)
+By Anton Revin
+https://opengameart.org/content/retropixel-icons-v1-9x9
+
+http://creativecommons.org/publicdomain/zero/1.0/
\ No newline at end of file
diff --git a/graphics/health_plus_9x9.png b/graphics/health_plus_9x9.png
new file mode 100644
index 000000000..2c77732ea
Binary files /dev/null and b/graphics/health_plus_9x9.png differ
diff --git a/src/cdogs/actors.c b/src/cdogs/actors.c
index 369d6135d..9d6991d12 100644
--- a/src/cdogs/actors.c
+++ b/src/cdogs/actors.c
@@ -554,6 +554,15 @@ void ActorHeal(TActor *actor, int health)
 {
 	actor->health += health;
 	actor->health = MIN(actor->health, ActorGetCharacter(actor)->maxHealth);
+	AddParticle ap;
+	memset(&ap, 0, sizeof ap);
+	ap.Pos = actor->Pos;
+	ap.Z = 10;
+	for (int i = 0; i < MAX(health / 20, 1); i++)
+	{
+		ap.Vel = svec2(RAND_FLOAT(-0.2f, 0.2f), RAND_FLOAT(-0.2f, 0.2f));
+		EmitterStart(&actor->healEffect, &ap);
+	}
 }
 
 void InjureActor(TActor * actor, int injury)
@@ -1331,6 +1340,10 @@ TActor *ActorAdd(NActorAdd aa)
 		&actor->barrelSmoke,
 		StrParticleClass(&gParticleClasses, "smoke"),
 		svec2_zero(), -0.05f, 0.05f, 3, 3, 0, 0, 10);
+	EmitterInit(
+		&actor->healEffect,
+		StrParticleClass(&gParticleClasses, "health_plus"),
+		svec2_zero(), -0.1f, 0.1f, 0, 0, 0, 0, 0);
 	GoreEmitterInit(&actor->blood1, "blood1");
 	GoreEmitterInit(&actor->blood2, "blood2");
 	GoreEmitterInit(&actor->blood3, "blood3");
@@ -1651,6 +1664,7 @@ static void ActorAddBloodSplatters(
 		AddParticle ap;
 		memset(&ap, 0, sizeof ap);
 		ap.Pos = a->Pos;
+		ap.Angle = -1;
 		ap.Z = 10;
 		ap.Vel = vel;
 		ap.Mask = ActorGetCharacter(a)->Class->BloodColor;
diff --git a/src/cdogs/actors.h b/src/cdogs/actors.h
index 278df482c..de91b6c38 100644
--- a/src/cdogs/actors.h
+++ b/src/cdogs/actors.h
@@ -154,6 +154,7 @@ typedef struct Actor
 	int ChatterCounter;
 
 	Emitter barrelSmoke;
+	Emitter healEffect;
 
 	// Gore emitters
 	Emitter blood1;
diff --git a/src/cdogs/bullet_class.c b/src/cdogs/bullet_class.c
index 3f0505a27..a870b77a5 100644
--- a/src/cdogs/bullet_class.c
+++ b/src/cdogs/bullet_class.c
@@ -22,7 +22,7 @@
     This file incorporates work covered by the following copyright and
     permission notice:
 
-    Copyright (c) 2013-2018 Cong Xu
+    Copyright (c) 2013-2019 Cong Xu
     All rights reserved.
 
     Redistribution and use in source and binary forms, with or without
@@ -753,7 +753,7 @@ static void LoadBullet(
 	if (json_find_first_label(node, "Falling"))
 	{
 		json_t *falling = json_find_first_label(node, "Falling")->child;
-		LoadInt(&b->Falling.GravityFactor, falling, "GravityFactor");
+		LoadFloat(&b->Falling.GravityFactor, falling, "GravityFactor");
 		LoadBool(&b->Falling.FallsDown, falling, "FallsDown");
 		LoadBool(&b->Falling.DestroyOnDrop, falling, "DestroyOnDrop");
 		LoadBool(&b->Falling.Bounces, falling, "Bounces");
@@ -787,7 +787,7 @@ static void LoadBullet(
 		b->HitSound.Wall != NULL ? b->HitSound.Wall : "",
 		b->WallBounces ? "true" : "false");
 	LOG(LM_MAP, LL_DEBUG,
-		"...hitsObjects(%s) gravity(%d) fallsDown(%s) destroyOnDrop(%s)...",
+		"...hitsObjects(%s) gravity(%f) fallsDown(%s) destroyOnDrop(%s)...",
 		b->HitsObjects ? "true" : "false", b->Falling.GravityFactor,
 		b->Falling.FallsDown ? "true" : "false",
 		b->Falling.DestroyOnDrop ? "true" : "false");
diff --git a/src/cdogs/bullet_class.h b/src/cdogs/bullet_class.h
index 514896cb0..569518059 100644
--- a/src/cdogs/bullet_class.h
+++ b/src/cdogs/bullet_class.h
@@ -22,7 +22,7 @@
     This file incorporates work covered by the following copyright and
     permission notice:
 
-    Copyright (c) 2013-2015, 2018 Cong Xu
+    Copyright (c) 2013-2015, 2018-2019 Cong Xu
     All rights reserved.
 
     Redistribution and use in source and binary forms, with or without
@@ -89,7 +89,7 @@ typedef struct
 	bool HitsObjects;
 	struct
 	{
-		int GravityFactor;	// 0 for non-falling bullets
+		float GravityFactor;	// 0 for non-falling bullets
 		bool FallsDown;	// if false, DZ is never negative
 		bool DestroyOnDrop;
 		bool Bounces;
diff --git a/src/cdogs/emitter.c b/src/cdogs/emitter.c
index 813fcf5df..604731acf 100644
--- a/src/cdogs/emitter.c
+++ b/src/cdogs/emitter.c
@@ -61,7 +61,8 @@ void EmitterStart(Emitter *em, const AddParticle *data)
 	const struct vec2 baseVel = svec2_rotate(
 		svec2(0, speed), RAND_FLOAT(0, MPI * 2));
 	e.u.AddParticle.Vel = svec2_add(data->Vel, baseVel);
-	e.u.AddParticle.Angle = RAND_FLOAT(0, MPI * 2);
+	e.u.AddParticle.Angle =
+		data->Angle >= 0 ? data->Angle : RAND_FLOAT(0, MPI * 2);
 	e.u.AddParticle.DZ = RAND_INT(em->minDZ, em->maxDZ);
 	e.u.AddParticle.Spin = RAND_DOUBLE(em->minRotation, em->maxRotation);
 	e.u.AddParticle.Mask = data->Mask;
diff --git a/src/cdogs/objs.h b/src/cdogs/objs.h
index 593b16245..12925be1d 100644
--- a/src/cdogs/objs.h
+++ b/src/cdogs/objs.h
@@ -81,8 +81,8 @@ typedef struct MobileObject
 	int ActorUID;	// unique ID of actor that owns this object
 					// (prevent self collision)
 	const BulletClass *bulletClass;
-	int z;
-	int dz;
+	float z;
+	float dz;
 	int count;
 	int range;
 	int flags;
diff --git a/src/cdogs/particle.c b/src/cdogs/particle.c
index b5f1d1b19..e5a2ab47c 100644
--- a/src/cdogs/particle.c
+++ b/src/cdogs/particle.c
@@ -202,7 +202,7 @@ static void LoadParticleClass(
 	}
 	c->RangeLow = MIN(c->RangeLow, c->RangeHigh);
 	c->RangeHigh = MAX(c->RangeLow, c->RangeHigh);
-	LoadInt(&c->GravityFactor, node, "GravityFactor");
+	LoadFloat(&c->GravityFactor, node, "GravityFactor");
 	LoadBool(&c->HitsWalls, node, "HitsWalls");
 	c->Bounces = true;
 	LoadBool(&c->Bounces, node, "Bounces");
@@ -317,12 +317,14 @@ static bool ParticleUpdate(Particle *p, const int ticks)
 			{
 				p->DZ -= p->Class->GravityFactor;
 			}
-			if (p->DZ == 0 && p->Z == 0)
+			if (fabsf(p->DZ) < fabs(p->Class->GravityFactor) &&
+				nearly_equal(p->Z, 0, 0.1f))
 			{
 				p->thing.Vel = svec2_zero();
 				p->Spin = 0;
 				// Fell to ground, draw below
 				p->thing.flags |= THING_DRAW_BELOW;
+				break;
 			}
 		}
 	}
diff --git a/src/cdogs/particle.h b/src/cdogs/particle.h
index 258fcfc4e..8f082d018 100644
--- a/src/cdogs/particle.h
+++ b/src/cdogs/particle.h
@@ -51,7 +51,7 @@ typedef struct
 	// -1 is infinite range
 	int RangeLow;
 	int RangeHigh;
-	int GravityFactor;
+	float GravityFactor;
 	bool HitsWalls;
 	bool Bounces;
 	bool WallBounces;
@@ -74,9 +74,9 @@ typedef struct
 	} u;
 	int ActorUID;
 	struct vec2 Pos;
-	int Z;
+	float Z;
 	double Angle;
-	int DZ;
+	float DZ;
 	double Spin;
 	int Count;
 	int Range;
